commit bc82ca3440990c1c681b8ffe84de5180726e333d
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Sun Apr 5 14:13:08 2009 +0200

    [evol] added licence information

diff --git a/ext/debian_apt/debian_apt.i b/ext/debian_apt/debian_apt.i
index b87da3e..0f94b1b 100644
--- a/ext/debian_apt/debian_apt.i
+++ b/ext/debian_apt/debian_apt.i
@@ -1,3 +1,20 @@
+/*
+ * Ruby-Debian, a Ruby interface for Debian packaging aspects
+ * Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
 
 %module "debian_apt"
 
diff --git a/ext/debian_apt/extconf.rb b/ext/debian_apt/extconf.rb
index 37d8573..0462eac 100644
--- a/ext/debian_apt/extconf.rb
+++ b/ext/debian_apt/extconf.rb
@@ -1,3 +1,21 @@
+#--
+# Ruby-Debian, a Ruby interface for Debian packaging aspects
+# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
+
 require 'mkmf'
 have_library('apt-pkg')
 create_makefile("debian_apt")
diff --git a/ext/debian_apt/post-clean.rb b/ext/debian_apt/post-clean.rb
index fa4bc4b..2715ad4 100755
--- a/ext/debian_apt/post-clean.rb
+++ b/ext/debian_apt/post-clean.rb
@@ -1,3 +1,20 @@
+#--
+# Ruby-Debian, a Ruby interface for Debian packaging aspects
+# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
 
 system("rm -f *_wrap.cxx")
 
diff --git a/ext/debian_apt/pre-setup.rb b/ext/debian_apt/pre-setup.rb
index 6ae7572..dcfe831 100755
--- a/ext/debian_apt/pre-setup.rb
+++ b/ext/debian_apt/pre-setup.rb
@@ -1,3 +1,20 @@
+#--
+# Ruby-Debian, a Ruby interface for Debian packaging aspects
+# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
 
 system("swig -c++ -ruby -Wall -autorename debian_apt.i")
 
diff --git a/lib/debian/version.rb b/lib/debian/version.rb
index 7d66f44..41416aa 100755
--- a/lib/debian/version.rb
+++ b/lib/debian/version.rb
@@ -1,5 +1,23 @@
 #!/usr/bin/ruby
 
+#--
+# Ruby-Debian, a Ruby interface for Debian packaging aspects
+# Copyright (c) 2009 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#++
+
 require 'debian_apt'
 
 module Debian_apt